﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.DataImporter.Data;
using HeuristicLab.DataImporter.Data.CommandBase;
using HeuristicLab.DataImporter.Data.Model;
using HeuristicLab.DataImporter.Command.View;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.DataImporter.Command {
  [StorableClass]
  [ViewableCommandInfoAttribute("Mean", 1, ColumnGroupState.DoubleColumnSelected | ColumnGroupState.AnySelectedColumnNotSorted,
    "Aggregation", Position = 0, OptionsView = typeof(AggregationCommandView))]
  public class AggregateWithMeanCommand : AggregateCommandBase {
    private AggregateWithMeanCommand()
      : base(null,string.Empty,null) {
    }

    public AggregateWithMeanCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
      : base(dataSet, columnGroupName, affectedColumns) {
    }

    public override string Description {
      get { return "Aggregate with mean function"; }
    }

    protected override IComparable AggregationFunction(ColumnBase col, int startIndex, int endIndex) {
      double value = 0;
      IComparable val;
      int cnt = 0;
      for (int i = startIndex; i < endIndex; i++) {
        val = col.GetValue(i);
        if (val != null) {
          value += (double)val;
          cnt++;
        }
      }
      return cnt !=0 ? value/cnt : (double?)null;
    }
  }
}
