﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.DataImporter.Data;
using HeuristicLab.DataImporter.Data.CommandBase;
using HeuristicLab.DataImporter.Data.Model;
using HeuristicLab.DataImporter.Command.View;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.DataImporter.Command {
  [StorableClass]
  [ViewableCommandInfoAttribute("Median", 1, ColumnGroupState.DoubleColumnSelected | ColumnGroupState.AnySelectedColumnNotSorted,
   "Aggregation", Position = 1, OptionsView = typeof(AggregationCommandView))]
  public class AggregateWithMedianCommand : AggregateCommandBase {
    private AggregateWithMedianCommand()
      : base(null,string.Empty,null) {
    }

    public AggregateWithMedianCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
      : base(dataSet, columnGroupName, affectedColumns) {
    }

    public override string Description {
      get { return "Aggregate with median function"; }
    }

    protected override IComparable AggregationFunction(ColumnBase col, int startIndex, int endIndex) {
      if (col is DoubleColumn)
        return ((DoubleColumn)col).GetMedian(startIndex, endIndex);
      else
        return null;
    }
  }
}
