﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.DataImporter.Data;
using HeuristicLab.DataImporter.Data.CommandBase;
using HeuristicLab.DataImporter.Data.Model;
using HeuristicLab.DataImporter.Command.View;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.DataImporter.Command {
  [StorableClass]
  [ViewableCommandInfoAttribute("Sum", 1, ColumnGroupState.DoubleColumnSelected | ColumnGroupState.AnySelectedColumnNotSorted,
   "Aggregation", Position = 2, OptionsView = typeof(AggregationCommandView))]
  public class AggregateWithSumCommand : AggregateCommandBase {
    private AggregateWithSumCommand()
      : base(null,string.Empty,null) {
    }

    public AggregateWithSumCommand(DataSet dataSet, string columnGroupName, int[] affectedColumns)
      : base(dataSet, columnGroupName, affectedColumns) {
    }

    public override string Description {
      get { return "Aggregate with sum function"; }
    }

    protected override IComparable AggregationFunction(ColumnBase col, int startIndex, int endIndex) {
      double value = 0;
      bool allNull = true;
      IComparable val;
      for (int i = startIndex; i < endIndex; i++) {
        val = col.GetValue(i);
        if (val != null) {
          allNull = false;
          value += (double)val;
        }
      }
      return allNull ? (double?)null : value;
    }
  }
}
